.\"	$NetBSD: ik.4,v 1.8 2001/08/18 14:37:47 wiz Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)ik.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt IK 4 vax
.Os
.Sh NAME
.Nm ik
.Nd Ikonas frame buffer, graphics device interface
.Sh SYNOPSIS
.Cd "ik0 at uba? csr 0172460 vector ikintr"
.Sh DESCRIPTION
NOTE: This driver has not been ported from
.Bx 4.4
yet.
.Pp
The
.Nm ik
driver
provides an interface to an Ikonas frame buffer graphics device.
Each minor device is a different frame buffer interface board.
When the device is opened, its interface registers are mapped,
via virtual memory, into the user processes address space.
This allows the user process very high bandwidth to the frame buffer
with no system call overhead.
.Pp
Bytes written or read from the device are
.Tn DMA Ns 'ed
from or to the interface.
The frame buffer
.Tn XY
address, its addressing mode, etc. must be set up by the
user process before calling write or read.
.Pp
Other communication with the driver is via ioctls.
The
.Dv IK_GETADDR
.Xr ioctl 2
returns the virtual address where the user process can
find the interface registers.
The
.Dv IK_WAITINT
.Xr ioctl 2
suspends the user process until the ikonas device
has interrupted (for whatever reason \(em the user process has to set
the interrupt enables).
.Sh FILES
.Bl -tag -width /dev/ikxx -compact
.It Pa /dev/ik
.El
.Sh DIAGNOSTICS
None.
.Sh HISTORY
The
.Nm
driver appeared in
.Bx 4.2 .
.Sh BUGS
An invalid access (e.g., longword) to a mapped interface register
can cause the system to crash with a machine check.
A user process could possibly cause infinite interrupts hence
bringing things to a crawl.
